#
# spec file for package pure-ftpd (Version 1.0.14)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  openldap2-client openldap2-devel openssl
# usedforbuild    aaa_base acl attr bash bind9-utils bison coreutils cpio cpp cvs cyrus-sasl2 db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils bzip2 cracklib gcc gdbm gettext heimdal-lib libtool openldap2-client openldap2-devel openssl perl rpm

Name:         pure-ftpd
Version:      1.0.14
Release:      99
URL:          http://www.pureftpd.org
Source:       ftp://download.sourceforge.net/pub/sourceforge/pureftpd/%{name}-%{version}.tar.bz2
Source1:      pure-ftpd.init
Source2:      pure-ftpd.pamd
Source3:      pure-ftpd.xinetd
Patch:        %{name}-%{version}.diff
Patch1:       %{name}-%{version}-detach.diff
Patch2:       %{name}-%{version}-readme.ldap.diff
Patch3:       pure-ftpd-1.0.14-DoSfix.diff
Group:        Productivity/Networking/Ftp/Servers
License:      GPL
Provides:     ftp-server pureftpd
PreReq:       %insserv_prereq
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Summary:      Lightweight, fast and secure FTP server

%description
Pure-FTPd is a fast, production-quality, standard-comformant FTP
server, based upon Troll-FTPd. Unlike other popular FTP servers, it has
no known security flaw, it is really trivial to set up and it is
especially designed for modern Linux kernels (setfsuid, sendfile,
capabilities) . Features include PAM support, IPv6, chroot()ed home
directories, virtual domains, built-in LS, anti-warez system, bandwidth
throttling, FXP, bounded ports for passive downloads, UL/DL ratios,
Apache log files and more.



%prep
%setup
%patch -p1
%patch1 -p1
%patch2 -p1
%patch3 -p0

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir} --with-ldap \
	--with-paranoidmsg --with-altlog --with-virtualhosts --with-ftpwho \
	--with-cookie --with-throttling --with-ratios --with-uploadscript --with-pam \
	--with-puredb --with-quotas --with-largefile %{_target_cpu}-suse-linux
make
cat configuration-file/pure-config.pl |grep -v "^print" | grep -v "^exec" > configuration-file/pure-config-args
echo "print join(\" \", @flg);" >> configuration-file/pure-config-args

%install
rm -rf "$RPM_BUILD_ROOT"
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/etc/openldap/schema
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init.d
install -m 755 configuration-file/pure-config.pl $RPM_BUILD_ROOT%{_prefix}/sbin
install -m 755 configuration-file/pure-config-args $RPM_BUILD_ROOT%{_prefix}/sbin
install -m 644 configuration-file/pure-ftpd.conf $RPM_BUILD_ROOT%{_sysconfdir}
install -m 755 $RPM_SOURCE_DIR/pure-ftpd.init $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/pure-ftpd
ln -sf ../../etc/init.d/pure-ftpd $RPM_BUILD_ROOT/%{_prefix}/sbin/rcpure-ftpd
install -m 644 $RPM_SOURCE_DIR/pure-ftpd.pamd $RPM_BUILD_ROOT/etc/pam.d/pure-ftpd
install -m 644 $RPM_SOURCE_DIR/pure-ftpd.xinetd $RPM_BUILD_ROOT/etc/xinetd.d/pure-ftpd
install -m 644 pureftpd.schema $RPM_BUILD_ROOT/etc/openldap/schema/

%clean
rm -rf "$RPM_BUILD_ROOT"

%postun
%insserv_cleanup

%files
%defattr(-, root, root)
%doc AUTHORS CONTACT COPYING NEWS THANKS README README.Contrib README.Configuration-File HISTORY README.Netfilter README.Virtual-Users README.LDAP pureftpd-ldap.conf
%dir /etc/openldap
%dir /etc/openldap/schema
%attr (0644, root, root) /etc/openldap/schema/pureftpd.schema
%attr (0755, root, root) %{_prefix}/bin/*
%attr (0755, root, root) %{_prefix}/sbin/*
%attr (0755, root, root) %config %{_sysconfdir}/init.d/pure-ftpd
%attr (0644, root, root) %config /etc/pam.d/pure-ftpd
%attr (0644, root, root) %doc %{_mandir}/man8/*
%attr (0644, root, root) %config(noreplace) %{_sysconfdir}/pure-ftpd.conf
%attr (0644, root, root) %config(noreplace) %{_sysconfdir}/xinetd.d/pure-ftpd

%changelog -n pure-ftpd
* Thu Jul 08 2004 - mmj@suse.de
- Apply fix to remove possible DoS attacks [#42821]
* Wed Apr 30 2003 - mmj@suse.de
- Fix to make pure-ftpd work with xinetd again
* Thu Mar 06 2003 - mmj@suse.de
- Fix the xinetd configuration file
* Fri Feb 28 2003 - mmj@suse.de
- Add note to README.LDAP about use_ldap in the pam config
* Fri Jan 31 2003 - mmj@suse.de
- Update to 1.0.14 and add a xinetd configuration file just in case
  the user wants to use it with xinetd. Default behaviour is still
  standalone.
* Mon Jan 20 2003 - mmj@suse.de
- Added patch to detach from fd 0, 1 and 2 [#22836]
* Wed Nov 27 2002 - mmj@suse.de
- Update to 1.0.13a which is a minor feature/bugfix-release
* Sat Oct 05 2002 - ckm@suse.de
- Changed default config file to only allow ro anonymous logins,
  and tightened security in case writing is enabled.
* Sat Aug 03 2002 - kukuk@suse.de
- Remove symlinks in postinstall script
- Add PreRequires for insserv
* Thu Jul 04 2002 - kukuk@suse.de
- Update to version 1.0.12 (per-user limits)
* Fri Apr 26 2002 - kukuk@suse.de
- Update to version 1.0.11 (minor bug fixes, better LDAP support)
* Mon Mar 11 2002 - kukuk@suse.de
- Fix permissions
* Sat Feb 16 2002 - kukuk@suse.de
- Fix print arguments [Bug #13389]
* Mon Feb 11 2002 - ro@suse.de
- flgs in perl-config parser is an array
* Thu Jan 24 2002 - kukuk@suse.de
- Update to version 1.0.8
- Compile with LDAP support
* Thu Nov 29 2001 - kukuk@suse.de
- Add pam config file
- Cleanup example config file
* Thu Nov 22 2001 - kukuk@suse.de
- Update to 1.0.3 (rename and quota fixes)
* Thu Nov 01 2001 - kukuk@suse.de
- Initial release of a secure ftp server with LFS
